require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_POWERPC_THREAD_INFO_H)) {
    eval 'sub _ASM_POWERPC_THREAD_INFO_H () {1;}' unless defined(&_ASM_POWERPC_THREAD_INFO_H);
    if(defined(&__KERNEL__)) {
	if(defined(&CONFIG_PPC64)) {
	    eval 'sub THREAD_SHIFT () {14;}' unless defined(&THREAD_SHIFT);
	} else {
	    eval 'sub THREAD_SHIFT () {13;}' unless defined(&THREAD_SHIFT);
	}
	eval 'sub THREAD_SIZE () {(1<<  &THREAD_SHIFT);}' unless defined(&THREAD_SIZE);
	unless(defined(&__ASSEMBLY__)) {
	    require 'linux/cache.ph';
	    require 'asm/processor.ph';
	    require 'asm/page.ph';
	    require 'linux/stringify.ph';
	    eval 'sub INIT_THREAD_INFO {
	        my($tsk) = @_;
    		eval q({ . &task = $tsk, . &exec_domain =  &default_exec_domain, . &cpu = 0, . &preempt_count = 1, . &restart_block = { . &fn =  &do_no_restart_syscall, }, . &flags = 0, });
	    }' unless defined(&INIT_THREAD_INFO);
	    eval 'sub init_thread_info () {( ($init_thread_union->{thread_info}));}' unless defined(&init_thread_info);
	    eval 'sub init_stack () {( ($init_thread_union->{stack}));}' unless defined(&init_stack);
	    if((defined(&THREAD_SHIFT) ? &THREAD_SHIFT : 0) >= (defined(&PAGE_SHIFT) ? &PAGE_SHIFT : 0)) {
		eval 'sub THREAD_ORDER () {( &THREAD_SHIFT -  &PAGE_SHIFT);}' unless defined(&THREAD_ORDER);
		if(defined(&CONFIG_DEBUG_STACK_USAGE)) {
		    eval 'sub alloc_thread_info {
		        my($tsk) = @_;
    			eval q(( &__get_free_pages( &GFP_KERNEL |  &__GFP_ZERO,  &THREAD_ORDER)));
		    }' unless defined(&alloc_thread_info);
		} else {
		    eval 'sub alloc_thread_info {
		        my($tsk) = @_;
    			eval q(( &__get_free_pages( &GFP_KERNEL,  &THREAD_ORDER)));
		    }' unless defined(&alloc_thread_info);
		}
		eval 'sub free_thread_info {
		    my($ti) = @_;
    		    eval q( &free_pages($ti,  &THREAD_ORDER));
		}' unless defined(&free_thread_info);
	    } else {
		if(defined(&CONFIG_DEBUG_STACK_USAGE)) {
		    eval 'sub alloc_thread_info {
		        my($tsk) = @_;
    			eval q( &kzalloc( &THREAD_SIZE,  &GFP_KERNEL));
		    }' unless defined(&alloc_thread_info);
		} else {
		    eval 'sub alloc_thread_info {
		        my($tsk) = @_;
    			eval q( &kmalloc( &THREAD_SIZE,  &GFP_KERNEL));
		    }' unless defined(&alloc_thread_info);
		}
		eval 'sub free_thread_info {
		    my($ti) = @_;
    		    eval q( &kfree($ti));
		}' unless defined(&free_thread_info);
	    }
	}
	eval 'sub PREEMPT_ACTIVE () {0x10000000;}' unless defined(&PREEMPT_ACTIVE);
	eval 'sub TIF_SYSCALL_TRACE () {0;}' unless defined(&TIF_SYSCALL_TRACE);
	eval 'sub TIF_NOTIFY_RESUME () {1;}' unless defined(&TIF_NOTIFY_RESUME);
	eval 'sub TIF_SIGPENDING () {2;}' unless defined(&TIF_SIGPENDING);
	eval 'sub TIF_NEED_RESCHED () {3;}' unless defined(&TIF_NEED_RESCHED);
	eval 'sub TIF_POLLING_NRFLAG () {4;}' unless defined(&TIF_POLLING_NRFLAG);
	eval 'sub TIF_32BIT () {5;}' unless defined(&TIF_32BIT);
	eval 'sub TIF_RUNLATCH () {6;}' unless defined(&TIF_RUNLATCH);
	eval 'sub TIF_ABI_PENDING () {7;}' unless defined(&TIF_ABI_PENDING);
	eval 'sub TIF_SYSCALL_AUDIT () {8;}' unless defined(&TIF_SYSCALL_AUDIT);
	eval 'sub TIF_SINGLESTEP () {9;}' unless defined(&TIF_SINGLESTEP);
	eval 'sub TIF_MEMDIE () {10;}' unless defined(&TIF_MEMDIE);
	eval 'sub TIF_SECCOMP () {11;}' unless defined(&TIF_SECCOMP);
	eval 'sub TIF_RESTOREALL () {12;}' unless defined(&TIF_RESTOREALL);
	eval 'sub TIF_NOERROR () {14;}' unless defined(&TIF_NOERROR);
	eval 'sub TIF_RESTORE_SIGMASK () {15;}' unless defined(&TIF_RESTORE_SIGMASK);
	eval 'sub _TIF_SYSCALL_TRACE () {(1<< &TIF_SYSCALL_TRACE);}' unless defined(&_TIF_SYSCALL_TRACE);
	eval 'sub _TIF_NOTIFY_RESUME () {(1<< &TIF_NOTIFY_RESUME);}' unless defined(&_TIF_NOTIFY_RESUME);
	eval 'sub _TIF_SIGPENDING () {(1<< &TIF_SIGPENDING);}' unless defined(&_TIF_SIGPENDING);
	eval 'sub _TIF_NEED_RESCHED () {(1<< &TIF_NEED_RESCHED);}' unless defined(&_TIF_NEED_RESCHED);
	eval 'sub _TIF_POLLING_NRFLAG () {(1<< &TIF_POLLING_NRFLAG);}' unless defined(&_TIF_POLLING_NRFLAG);
	eval 'sub _TIF_32BIT () {(1<< &TIF_32BIT);}' unless defined(&_TIF_32BIT);
	eval 'sub _TIF_RUNLATCH () {(1<< &TIF_RUNLATCH);}' unless defined(&_TIF_RUNLATCH);
	eval 'sub _TIF_ABI_PENDING () {(1<< &TIF_ABI_PENDING);}' unless defined(&_TIF_ABI_PENDING);
	eval 'sub _TIF_SYSCALL_AUDIT () {(1<< &TIF_SYSCALL_AUDIT);}' unless defined(&_TIF_SYSCALL_AUDIT);
	eval 'sub _TIF_SINGLESTEP () {(1<< &TIF_SINGLESTEP);}' unless defined(&_TIF_SINGLESTEP);
	eval 'sub _TIF_SECCOMP () {(1<< &TIF_SECCOMP);}' unless defined(&_TIF_SECCOMP);
	eval 'sub _TIF_RESTOREALL () {(1<< &TIF_RESTOREALL);}' unless defined(&_TIF_RESTOREALL);
	eval 'sub _TIF_NOERROR () {(1<< &TIF_NOERROR);}' unless defined(&_TIF_NOERROR);
	eval 'sub _TIF_RESTORE_SIGMASK () {(1<< &TIF_RESTORE_SIGMASK);}' unless defined(&_TIF_RESTORE_SIGMASK);
	eval 'sub _TIF_SYSCALL_T_OR_A () {( &_TIF_SYSCALL_TRACE| &_TIF_SYSCALL_AUDIT| &_TIF_SECCOMP);}' unless defined(&_TIF_SYSCALL_T_OR_A);
	eval 'sub _TIF_USER_WORK_MASK () {( &_TIF_NOTIFY_RESUME |  &_TIF_SIGPENDING |  &_TIF_NEED_RESCHED |  &_TIF_RESTORE_SIGMASK);}' unless defined(&_TIF_USER_WORK_MASK);
	eval 'sub _TIF_PERSYSCALL_MASK () {( &_TIF_RESTOREALL| &_TIF_NOERROR);}' unless defined(&_TIF_PERSYSCALL_MASK);
	eval 'sub TLF_NAPPING () {0;}' unless defined(&TLF_NAPPING);
	eval 'sub _TLF_NAPPING () {(1<<  &TLF_NAPPING);}' unless defined(&_TLF_NAPPING);
    }
}
1;
