require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__POWERPC_TIME_H)) {
    eval 'sub __POWERPC_TIME_H () {1;}' unless defined(&__POWERPC_TIME_H);
    if(defined(&__KERNEL__)) {
	require 'linux/types.ph';
	require 'linux/percpu.ph';
	require 'asm/processor.ph';
	if(defined(&CONFIG_PPC_ISERIES)) {
	    require 'asm/paca.ph';
	    require 'asm/firmware.ph';
	    require 'asm/iseries/hv_call.ph';
	}
	eval 'sub DEFAULT_PROC_FREQ () {( &DEFAULT_TB_FREQ * 8);}' unless defined(&DEFAULT_PROC_FREQ);
	eval 'sub DEFAULT_TB_FREQ () {125000000;}' unless defined(&DEFAULT_TB_FREQ);
	if(defined(&CONFIG_6xx)) {
	    eval 'sub __USE_RTC () {
	        eval q((! &cpu_has_feature( &CPU_FTR_USE_TB)));
	    }' unless defined(&__USE_RTC);
	} else {
	    eval 'sub __USE_RTC () {
	        eval q(0);
	    }' unless defined(&__USE_RTC);
	}
	if(defined( &CONFIG_403GCX)) {
	} else {
	}
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub get_tbu {
	    my($void) = @_;
    	    eval q({ my $tbu;  $tbu; });
	}' unless defined(&get_tbu);
	eval 'sub get_rtcl {
	    my($void) = @_;
    	    eval q({ my $rtcl;  &asm  &volatile(\\"mfrtcl %0\\" : \\"=r\\" ( $rtcl));  $rtcl; });
	}' unless defined(&get_rtcl);
	eval 'sub get_rtc {
	    my($void) = @_;
    	    eval q({ my $hi,  &lo,  &hi2;  &do {  &asm  &volatile(\\"mfrtcu %0; mfrtcl %1; mfrtcu %2\\" : \\"=r\\" ( $hi), \\"=r\\" ( &lo), \\"=r\\" ( &hi2)); }  &while ( &hi2 !=  $hi); ( &u64) $hi * 1000000000+  &lo; });
	}' unless defined(&get_rtc);
	if(defined(&CONFIG_PPC64)) {
	    eval 'sub get_tb {
	        my($void) = @_;
    		eval q({  &mftb(); });
	    }' unless defined(&get_tb);
	} else {
	    eval 'sub get_tb {
	        my($void) = @_;
    		eval q({ my $tbhi,  &tblo,  &tbhi2;  &do {  $tbhi =  &get_tbu();  &tblo =  &get_tbl();  &tbhi2 =  &get_tbu(); }  &while ( $tbhi !=  &tbhi2); (( &u64) $tbhi << 32) |  &tblo; });
	    }' unless defined(&get_tb);
	}
	eval 'sub set_tb {
	    my($upper,$lower) = @_;
    	    eval q({  &mtspr( &SPRN_TBWL, 0);  &mtspr( &SPRN_TBWU, $upper);  &mtspr( &SPRN_TBWL, $lower); });
	}' unless defined(&set_tb);
	if(defined( &CONFIG_40x)) {
	} else {
	}
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub set_dec {
	    my($val) = @_;
    	    eval q({  &mtspr( &SPRN_DEC, $val);  &endif });
	}' unless defined(&set_dec);
	eval 'sub tb_ticks_since {
	    my($tstamp) = @_;
    	    eval q({  &if ( &__USE_RTC()) { \'int\'  &delta =  &get_rtcl() -  $tstamp;  &delta < 0?  &delta + 1000000000:  &delta; }  &get_tbl() - $tstamp; });
	}' unless defined(&tb_ticks_since);
	eval 'sub mulhwu {
	    my($x,$y) = @_;
    	    eval q(({\'unsigned z\';  &asm (\\"mulhwu %0,%1,%2\\" : \\"=r\\" ( &z) : \\"r\\" ($x), \\"r\\" ($y));  &z;}));
	}' unless defined(&mulhwu);
	if(defined(&CONFIG_PPC64)) {
	    eval 'sub mulhdu {
	        my($x,$y) = @_;
    		eval q(({\'unsigned long z\';  &asm (\\"mulhdu %0,%1,%2\\" : \\"=r\\" ( &z) : \\"r\\" ($x), \\"r\\" ($y));  &z;}));
	    }' unless defined(&mulhdu);
	} else {
	}
	if(defined(&CONFIG_VIRT_CPU_ACCOUNTING)) {
	} else {
	    eval 'sub account_process_vtime {
	        my($tsk) = @_;
    		eval q( &do { }  &while (0));
	    }' unless defined(&account_process_vtime);
	}
	if(defined( &CONFIG_VIRT_CPU_ACCOUNTING)  && defined( &CONFIG_PPC_SPLPAR)) {
	} else {
	    eval 'sub calculate_steal_time () {
	        eval q( &do { }  &while (0));
	    }' unless defined(&calculate_steal_time);
	    eval 'sub snapshot_timebases () {
	        eval q( &do { }  &while (0));
	    }' unless defined(&snapshot_timebases);
	}
    }
}
1;
